"""
TBD
"""

__author__ = "Lukas Mahler"
__version__ = "0.0.0"
__date__ = "24.10.2021"
__email__ = "m@hler.eu"
__status__ = "Development"


# Default
import sys
import json
import time
import inspect

# Custom
import ts3

# Self
from src import util


def follow(self, invkr_id, parameter):
    """

    """

    if not parameter:
        err = "Please use the command like this: .follow TARGET"
        self.bot.sendtextmessage(targetmode=1, target=invkr_id, msg=err)
        return

    target = parameter[0]
    clid = self.identifytarget(target)
    cid = self.bot.clientinfo(clid=int(clid))[0]["cid"]
    self.bot.clientmove(clid=self.myid, cid=cid)


def help(self, invkr_id):
    """

    """
    # Find all functions in this submodule
    cmds = [f[0] for f in inspect.getmembers(sys.modules[__name__], inspect.isfunction)]
    msg = f"\n\nList of commands:\n---------------------\n.{f'{chr(10)}.'.join(cmds)}"
    self.bot.sendtextmessage(targetmode=1, target=invkr_id, msg=msg)


def info(self, invkr_id):
    """

    """
    # TODO implement more then just the runtime
    msg = f"\n\nRuntime: {util.getRuntime(self.started)}\n" \
          f"Version: {self.version}"
    self.bot.sendtextmessage(targetmode=1, target=invkr_id, msg=msg)


def msglist(self, invkr_id, parameter):
    """
    Message the invoker of the function either a list of channels or a list of clients.
    """

    what = parameter[0]
    mydict = {}

    if what == "channel":
        channels = self.bot.channellist()
        for channel in channels:
            order = channel["channel_order"]
            mydict[order] = [channel["channel_name"], channel["cid"]]

        mydict = dict(sorted(mydict.items()))
        msg = json.dumps(mydict)

    elif what == "clients":
        clients = self.bot.clientlist()
        for client in clients:
            mydict[client["client_nickname"]] = {"clid": client["clid"], "cldbid": client["client_database_id"]}
        mydict = dict(sorted(mydict.items()))
        msg = json.dumps(mydict)

    elif what == "groups":
        groups = self.bot.servergrouplist()
        for group in groups:
            mydict[group["name"]] = {"sgid": group["sgid"], "sortid": group["sortid"]}
        msg = json.dumps(mydict)

    else:
        msg = None

    self.bot.sendtextmessage(targetmode=1, target=invkr_id, msg=msg)


def mute(self, invkr_id, parameter):
    """
    Assign the mute group to a user.
    """

    if not parameter:
        err = "Please use the command like this: .mute TARGET"
        self.bot.sendtextmessage(targetmode=1, target=invkr_id, msg=err)
        return

    target = parameter[0]
    clid = self.identifytarget(target)
    cldbid = self.clid2cldbid(clid)

    try:
        self.bot.servergroupaddclient(sgid=self.sgid_mute, cldbid=cldbid)
    except ts3.query.TS3QueryError as e:
        err = f"Failed to add to group: [{e}]"
        self.bot.sendtextmessage(targetmode=1, target=invkr_id, msg=err)
        return


def notifyAdmin(self):
    """
    Ping every available admin.
    """

    clients = self.bot.clientlist()
    clients = [client for client in clients if client["client_type"] != "1"]
    for client in clients:
        cldbid = client["client_database_id"]
        clid = client["clid"]
        if self.isadmin(cldbid):
            msg = "<Keep this chat open to use commands>"
            self.bot.sendtextmessage(targetmode=1, target=clid, msg=msg)

        if not self.whitelisted:
            time.sleep(1)


def unmute(self, invkr_id, parameter):
    """
    Remove the mute group to a user.
    """

    if not parameter:
        err = "Please use the command like this: .unmute TARGET"
        self.bot.sendtextmessage(targetmode=1, target=invkr_id, msg=err)
        return

    target = parameter[0]
    clid = self.identifytarget(target)
    cldbid = self.clid2cldbid(clid)

    try:
        self.bot.servergroupdelclient(sgid=self.sgid_mute, cldbid=cldbid)
    except ts3.query.TS3QueryError as e:
        err = f"Failed to remove from group: [{e}]"
        self.bot.sendtextmessage(targetmode=1, target=invkr_id, msg=err)
        return


if __name__ == "__main__":
    exit()
